<template>
  <section
    id="game_banner"
    class="max-w-[1200px]"
    :style="`--btnActiveBg: ${btnActiveBg}; --btnBg: ${btnBg};`"
  >
    <section id="game_title_banner" class="w-full h-[110px] relative">
      <img
        :src="
          getAssetImage(
            'assets/theme/light_flexible_1/desktop/images/home_game_banner.png'
          )
        "
        alt="decoration style"
        loading="lazy"
      />
      <div class="banner__title w-[308px] absolute left-[37.5%] top-5">
        <h2 class="text-6xl text-center text-blue-500 drop-shadow-lg">
          {{ $t("games") }}
        </h2>
      </div>
    </section>
    <section class="flex justify-center pt-12">
      <ul class="flex gap-2 text-[16px]">
        <li
          v-if="checkHasTab('Sports')"
          class="min-w-[125px] px-2 h-10 game__btn"
          :class="{ active: activeComponent === 'SportsHomeBanner' }"
          @click="activeComponent = 'SportsHomeBanner'"
        >
          <span class="text-inherit text-[16px] font-medium">{{
            $t("sport")
          }}</span>
        </li>
        <li
          v-if="checkHasTab('Virtual Sports')"
          class="min-w-[125px] px-2 h-10 game__btn"
          :class="{ active: activeComponent === 'VirtualSportsHomeBanner' }"
          @click="activeComponent = 'VirtualSportsHomeBanner'"
        >
          <span class="text-inherit text-[16px] font-medium">{{
            $t("virtual_sports")
          }}</span>
        </li>
        <li
          v-if="checkHasTab('Live Casino')"
          class="min-w-[125px] px-2 h-10 game__btn"
          :class="{ active: activeComponent === 'LiveCasinoHomeBanner' }"
          @click="activeComponent = 'LiveCasinoHomeBanner'"
        >
          <span class="text-inherit text-[16px] font-medium">{{
            $t("live_casino")
          }}</span>
        </li>
        <li
          v-if="checkHasTab('Games')"
          class="min-w-[125px] px-2 h-10 game__btn"
          :class="{ active: activeComponent === 'GamesHomeBanner' }"
          @click="activeComponent = 'GamesHomeBanner'"
        >
          <span class="text-inherit text-[16px] font-medium">{{
            $t("game")
          }}</span>
        </li>
        <li
          v-if="checkHasTab('Cock Fight')"
          class="min-w-[125px] px-2 h-10 game__btn"
          :class="{ active: activeComponent === 'CockfightHomeBanner' }"
          @click="activeComponent = 'CockfightHomeBanner'"
        >
          <span class="text-inherit text-[16px] font-medium">{{
            $t("cock_fight")
          }}</span>
        </li>
        <li
          v-if="hasPoker"
          class="min-w-[125px] px-2 h-10 game__btn"
          :class="{ active: activeComponent === 'PokerHomeBanner' }"
          @click="activeComponent = 'PokerHomeBanner'"
        >
          <span class="text-inherit text-[16px] font-medium">{{
            $t("poker")
          }}</span>
        </li>
        <li
          v-if="hasLottery"
          class="w-[125px] px-2 h-10 game__btn"
          :class="{ active: activeComponent === 'LotteryHomeBanner' }"
          @click="activeComponent = 'LotteryHomeBanner'"
        >
          <span class="text-inherit text-[16px] font-medium">{{
            $t("lottery")
          }}</span>
        </li>
      </ul>
    </section>
    <section id="game_container" class="mt-2 mb-5">
      <transition name="slide-fade" mode="out-in">
        <component :is="activeComponent" />
      </transition>
    </section>
  </section>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import _ from "lodash";
import SportsHomeBanner from "./game-banner/SportHomeBanner.client.vue";
import VirtualSportsHomeBanner from "./game-banner/VirtualSportHomeBanner.client.vue";
import LiveCasinoHomeBanner from "./game-banner/CasinoHomeBanner.client.vue";
import GamesHomeBanner from "./game-banner/GameHomeBanner.client.vue";
import CockfightHomeBanner from "./game-banner/CockfightHomeBanner.client.vue";
import LotteryHomeBanner from "./game-banner/LotteryHomeBanner.client.vue";
import PokerHomeBanner from "./game-banner/PokerHomeBanner.client.vue";
import { store } from "@/store";
import { menuTabHeaders } from "@/composables/useTheme";
import { gameStore } from "~~/store/game";

export default defineComponent({
  components: {
    SportsHomeBanner,
    VirtualSportsHomeBanner,
    LiveCasinoHomeBanner,
    GamesHomeBanner,
    CockfightHomeBanner,
    LotteryHomeBanner,
    PokerHomeBanner,
  },
  setup() {
    const hasPoker = computed(
      () =>
        gameStore.state.games.findIndex((item) => item.TabType === "Poker") >= 0
    );
    const hasLottery = computed(
      () =>
        gameStore.state.games.findIndex((item) => item.TabType === "Lottery") >=
        0
    );
    const activeComponent = ref(
      `${
        _.first(menuTabHeaders.value)?.TabType?.replace(/\W/g, "") ?? "Sports"
      }HomeBanner`
    );
    const checkHasTab = (tabType: string) =>
      menuTabHeaders.value.findIndex((tab) => tab.TabType === tabType) >= 0;
    const { getAssetImage } = commonHelper;
    const btnActiveBg = `url('${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/btn-background-active.png"
    )}')`;
    const btnBg = `url('${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/btn-background.png"
    )}')`;

    return {
      hasPoker,
      activeComponent,
      hasLottery,
      checkHasTab,
      getAssetImage,
      btnActiveBg,
      btnBg,
    };
  },
});
</script>

<style scoped lang="scss">
.game__btn {
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  background: var(--btnBg);
  box-shadow: 0 2px 4px 0 rgba(93, 167, 235, 0.8);
  border-radius: 30.6px;
  background-size: cover;
  color: inherit;
  transition: all 0.5s;
}

.game__btn:hover::after {
  content: "";
  display: block;
  width: 100%;
  height: 100%;
  position: absolute;
  z-index: 2;
  border-radius: 30.6px;
  background-color: rgba(255, 255, 255, 0.2);
}
.game__btn.active {
  background: var(--btnActiveBg);
  background-size: cover;
  color: #fff;
}
</style>
